added files to run smoothly on debian
[sfa.git] / init.d / sfa
index 7cb510c..2fda7e0 100755 (executable)
 # source function library
 . /etc/init.d/functions
 
+# <jordan>
+
+# borrowed from postgresql
+versions=()
+for v in `ls /usr/lib/postgresql/ 2>/dev/null`; do
+    if [ -x /usr/lib/postgresql/$v/bin/pg_ctl ] && [ ! -x /etc/init.d/postgresql-$v ]; then
+        versions+=($v)
+    fi
+done
+if [[ ${#versions[*]} == "0" ]]; then 
+    echo "E: Missing postgresql installation. Aborting."
+    exit
+fi
+if [[ ${#versions[*]} != "1" ]]; then 
+    echo "E: Too many postgresql versions installed. Aborting."
+    exit
+fi
+pgver=${versions[0]}
+
+LOCKFILE=/var/run/sfa-start.py
+# </jordan>
+
 # Default locations
-PGDATA=/var/lib/pgsql/data
+PGDATA=/etc/postgresql/$pgver/main/
 postgresql_conf=$PGDATA/postgresql.conf
 pghba_conf=$PGDATA/pg_hba.conf
 postgresql_sysconfig=/etc/sysconfig/pgsql
 
-# PLC consolidated (merged) config file
-plc_whole_config=/etc/planetlab/plc_config.xml
 # SFA consolidated (merged) config file
-sfa_whole_config=/etc/sfa/sfa_config.xml
+sfa_whole_config=/etc/sfa/sfa_config
 # SFA default config (read-only template)
 sfa_default_config=/etc/sfa/default_config.xml
 # SFA local (site-dependent) file
-sfa_local_config=/etc/sfa/configs/site.xml
+sfa_local_config=/etc/sfa/configs/site_config
+sfa_local_config_xml=/etc/sfa/configs/site_config.xml
 
 # Source sfa shell config if present 
-[ -f /etc/sfa/sfa_config ] && . /etc/sfa/sfa_config
+[ -f /etc/sfa/sfa_config.sh ] && . /etc/sfa/sfa_config.sh
 
 # Export so that we do not have to specify -p to psql invocations
 export PGPORT=$SFA_DB_PORT
@@ -46,7 +67,7 @@ check ()
 function postgresql_check () {
 
     # wait until postmaster is up and running - or 10s max
-    if status postmaster >& /dev/null && [ -f /var/lock/subsys/postgresql ] ; then
+    if status postgres >& /dev/null && [ -f /var/run/postgresql/$pgver-main.pid ] ; then
        # The only way we can be sure is if we can access it
        for i in $(seq 1 10) ; do
            # Must do this as the postgres user initially (before we
@@ -65,43 +86,13 @@ DATE=$(date +"%Y-%m-%d-%H-%M-%S")
 # Dumps the database - optional argument to specify filename suffix
 function dump_sfa_db() {
     if [ -n "$1" ] ; then suffix="-$1" ; else suffix="" ; fi
-    dumpfile=/var/lib/pgsql/backups/$(date +"${SFA_DB_NAME}.${DATE}${suffix}.sql")
+    mkdir -p /usr/share/sfa/backups
+    dumpfile=/usr/share/sfa/backups/$(date +"${SFA_DB_NAME}.${DATE}${suffix}.sql")
     pg_dump -U $SFA_DB_USER $SFA_DB_NAME > $dumpfile
+    echo "Saved sfa database in $dumpfile"
     check
 }
 
-# Updates the database by applying migration scripts
-# using sqlalchemy-migrate for this 
-# migrate repo is /usr/share/sfa/migrations/
-# and version scripts are thus in /usr/share/sfa/migrations/versions/
-function db_migrate() {
-
-    # only if enabled
-    [ "$SFA_DB_ENABLED" == 1 ] || return
-
-    alchemy_url="postgresql+psycopg2://${SFA_DB_USER}:${SFA_DB_PASSWORD}@:${SFA_DB_PORT}/${SFA_DB_NAME}"
-    migrate_repo="/usr/share/sfa/migrations"
-    # check if under version control, and initialize it otherwise
-    if ! sqlalchemy-migrate db_version --url=$alchemy_url $migrate_repo >& /dev/null ; then
-       # at this point it would make sense to
-       # check that the 'users' table is in the db
-       # if not, backup/dump, and run a nuke/import
-       # and then only init the db version to 0
-       echo -n $"version init in db ${SFA_DB_NAME}" 
-       sqlalchemy-migrate version_control --url=$alchemy_url $migrate_repo 
-    fi
-    version_before=$(sqlalchemy-migrate db_version --url=$alchemy_url $migrate_repo)
-    check
-    sqlalchemy-migrate upgrade --url=$alchemy_url $migrate_repo 2> /dev/null
-    check
-    version_after=$(sqlalchemy-migrate db_version --url=$alchemy_url $migrate_repo)
-    if [ "$version_before" != "$version_after" -o "$ERRORS" != 0 ] ; then
-       MESSAGE=$"DB version: $version_before -> $version_after"
-       echo -n "$MESSAGE"
-       [ "$ERRORS" == 0 ] && success "$MESSAGE" || failure "$MESSAGE" ; echo
-    fi
-}
-
 # Regenerate configuration files - almost verbatim from plc.init
 function reload () {
     force=$1
@@ -112,8 +103,8 @@ function reload () {
     files=( $sfa_default_config $sfa_local_config )
     for file in "${files[@]}" ; do
        if [ -n "$force" -o $file -nt $sfa_whole_config ] ; then
-           tmp=$(mktemp /tmp/sfa_config.xml.XXXXXX)
-           plc-config --xml "${files[@]}" >$tmp
+           tmp=$(mktemp /tmp/sfa_config.XXXXXX)
+           sfa-config --python "${files[@]}" >$tmp
            if [ $? -eq 0 ] ; then
                mv $tmp $sfa_whole_config
                chmod 444 $sfa_whole_config
@@ -126,11 +117,15 @@ function reload () {
     done
 
     # Convert configuration to various formats
-    if [ -n "$force" -o $sfa_whole_config -nt /etc/sfa/sfa_config ] ; then
-       plc-config --shell $sfa_whole_config > /etc/sfa/sfa_config
+    if [ -f $sfa_local_config_xml ] ; then
+    sfa-config --python $sfa_local_config_xml > $sfa_local_config 
+    rm $sfa_local_config_xml 
+    fi
+    if [ -n "$force" -o $sfa_local_config -nt $sfa_whole_config ] ; then
+       sfa-config --python $sfa_default_config $sfa_local_config > $sfa_whole_config
     fi
-    if [ -n "$force" -o $sfa_whole_config -nt /etc/sfa/sfa_config.py ] ; then
-       plc-config --python $sfa_whole_config > /etc/sfa/sfa_config.py
+    if [ -n "$force" -o $sfa_whole_config -nt /etc/sfa/sfa_config.sh ] ; then
+       sfa-config --shell $sfa_default_config $sfa_local_config > /etc/sfa/sfa_config.sh
     fi
 #    if [ -n "$force" -o $sfa_whole_config -nt /etc/sfa/php/sfa_config.php ] ; then
 #      mkdir -p /etc/sfa/php
@@ -145,7 +140,7 @@ function reload () {
     #gen-sfa-cm-config.py        
 
     # reload the shell version
-    [ -f /etc/sfa/sfa_config ] && . /etc/sfa/sfa_config
+    [ -f /etc/sfa/sfa_config.sh ] && . /etc/sfa/sfa_config.sh
 
 }
 
@@ -153,7 +148,7 @@ function reload () {
 function db_start () {
     
     # only if enabled
-    [ "$SFA_DB_ENABLED" == 1 ] || return
+    [ "$SFA_DB_ENABLED" == 1 -o "$SFA_DB_ENABLED" == True ] || return
 
     if ! rpm -q myplc >& /dev/null; then
 
@@ -220,7 +215,7 @@ function db_start () {
        ######## compute a password if needed
        if [ -z "$SFA_DB_PASSWORD" ] ; then
            SFA_DB_PASSWORD=$(uuidgen)
-           plc-config --category=sfa_db --variable=password --value="$SFA_DB_PASSWORD" --save=$sfa_local_config $sfa_local_config >& /dev/null
+           sfa-config --category=sfa_db --variable=password --value="$SFA_DB_PASSWORD" --save=$sfa_local_config $sfa_local_config >& /dev/null
            reload force
        fi
 
@@ -232,8 +227,8 @@ function db_start () {
        PLC_DB_USER=$(plc-config --category=plc_db --variable=user)
        PLC_DB_PASSWORD=$(plc-config --category=plc_db --variable=password)
        # store this as the SFA user/password 
-       plc-config --category=sfa_db --variable=user --value=$PLC_DB_USER --save=$sfa_local_config $sfa_local_config >& /dev/null
-       plc-config --category=sfa_db --variable=password --value=$PLC_DB_PASSWORD --save=$sfa_local_config $sfa_local_config >& /dev/null
+       sfa-config --category=sfa_db --variable=user --value=$PLC_DB_USER --save=$sfa_local_config $sfa_local_config >& /dev/null
+       sfa-config --category=sfa_db --variable=password --value=$PLC_DB_PASSWORD --save=$sfa_local_config $sfa_local_config >& /dev/null
        reload force
     fi
 
@@ -261,8 +256,10 @@ function db_start () {
        check
     fi
     check
+    # mention sfaadmin.py instead of just sfaadmin for people who do not install through rpm
+    sfaadmin.py reg sync_db
 
-    MESSAGE=$"Checking for PostgreSQL server"
+    MESSAGE=$"SFA: Checking for PostgreSQL server"
     echo -n "$MESSAGE"
     [ "$ERRORS" == 0 ] && success "$MESSAGE" || failure "$MESSAGE" ; echo
 }
@@ -271,7 +268,7 @@ function db_start () {
 function db_stop () {
 
     # only if enabled
-    [ "$SFA_DB_ENABLED" == 1 ] || return
+    [ "$SFA_DB_ENABLED" == 1 -o "$SFA_DB_ENABLED" == True ] || return
 
     # not too nice, but.. when co-located with myplc we'll let it start/stop postgresql
     if ! rpm -q myplc >& /dev/null ; then
@@ -288,21 +285,21 @@ function start() {
     reload
 
     db_start
-    db_migrate
+    # migrations are now handled in the code by sfa.storage.dbschema
 
     # install peer certs
-    action $"SFA installing peer certs" daemon /usr/bin/sfa-start.py -t -d $OPTIONS 
+    action $"SFA: installing peer certs" daemon /usr/bin/sfa-start.py -t -d $OPTIONS 
 
-    [ "$SFA_REGISTRY_ENABLED" == 1 ] && action $"SFA Registry" daemon /usr/bin/sfa-start.py -r -d $OPTIONS
+    [ "$SFA_REGISTRY_ENABLED" == 1 -o "$SFA_REGISTRY_ENABLED" == True ] && action $"SFA: Registry" daemon /usr/bin/sfa-start.py -r -d $OPTIONS
     
-    [ "$SFA_AGGREGATE_ENABLED" == 1 ] && action $"SFA Aggregate" daemon /usr/bin/sfa-start.py -a -d $OPTIONS
+    [ "$SFA_AGGREGATE_ENABLED" == 1  -o "$SFA_AGGREGATE_ENABLED" == True ] && action $"SFA: Aggregate" daemon /usr/bin/sfa-start.py -a -d $OPTIONS
         
-    [ "$SFA_SM_ENABLED" == 1 ] && action "SFA SliceMgr" daemon /usr/bin/sfa-start.py -s -d $OPTIONS
+    [ "$SFA_SM_ENABLED" == 1 -o "$SFA_SM_ENABLED" == True ] && action "SFA: SliceMgr" daemon /usr/bin/sfa-start.py -s -d $OPTIONS
 
     [ "$SFA_FLASHPOLICY_ENABLED" == 1 ] && \
         action "Flash Policy Server" daemon /usr/bin/sfa_flashpolicy.py --file="$SFA_FLASHPOLICY_CONFIG_FILE" --port=$SFA_FLASHPOLICY_PORT -d
 
-    touch /var/lock/subsys/sfa-start.py
+    touch $LOCKFILE
 
 }
 
@@ -311,7 +308,7 @@ function stop() {
 
     db_stop
 
-    rm -f /var/lock/subsys/sfa-start.py
+    rm -f $LOCKFILE
 }
 
 
@@ -321,7 +318,7 @@ case "$1" in
     reload) reload force ;;
     restart) stop; start ;;
     condrestart)
-       if [ -f /var/lock/subsys/sfa-start.py ]; then
+       if [ -f $LOCKFILE ]; then
             stop
             start
        fi
@@ -330,8 +327,11 @@ case "$1" in
        status sfa-start.py
        RETVAL=$?
        ;;
+    dbdump)
+       dump_sfa_db
+       ;;
     *)
-       echo $"Usage: $0 {start|stop|reload|restart|condrestart|status}"
+       echo $"Usage: $0 {start|stop|reload|restart|condrestart|status|dbdump}"
        exit 1
        ;;
 esac